<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'}">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item" placeholder="结束时间" readonly>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="save">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="update">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="remove">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                    <!-- 序号 -->
                    <script type="text/html" id="rowNum">
                        {{d.LAY_INDEX}}
                    </script>
                    <!-- 操作按钮 -->
                    <script type="text/html" id="bindMenu">
                        {{#  if(d.menuId == null || d.menuId == ''){ }}
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="bindMenu">绑定</button>
                            <button type="button" class="layui-btn layui-btn-warm layui-btn-sm" lay-event="contactMenu">关联</button>
                        </div>
                        {{#  } else { }}
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="unBindMenu">解绑</button>
                        </div>
                        {{#  } }}
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var common = layui.common;
        var resizeTimeout = null;

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path('api/oauth2client/listpage', []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '#rowNum'},
                        {field:'clientName', width:250, title: '客户端名称', align:'center',},
                        {field:'scope', width:60, title: '范围', align:'center',
                            templet: function(item) {
                                var value;
                                switch (item.scope) {
                                    case 'all':
                                        value = '全部';
                                        break;
                                    case 'read':
                                        value = '只读';
                                        break;
                                    case 'write':
                                        value = '只写';
                                        break;
                                    default:
                                        value = '无';
                                }
                                return value;
                            }
                        },
                        {field:'authorizedGrantTypes', width:200, title: '授权模式', align:'center',
                            templet: function(item) {
                                return item.authorizedGrantTypes.replace(/(authorization_code)/g, '授权码模式')
                                    .replace(/(password)/g, '密码模式')
                                    .replace(/(client_credentials)/, '客户端模式')
                                    .replace(/(implicit)/g, '简单模式')
                                    .replace(/refresh_token/g, '刷新');
                            }
                        },
                        {field:'webServerRedirectUri', width: 300, title: '重定向链接', align:'center',
                            templet: function(item) {
                                return '<a href="'+ item.webServerRedirectUri +'" target="_top">'+ item.webServerRedirectUri +'</a>';
                            }
                        },
                        {field:'authorities', width:60, title: '权限', align:'center',
                            templet: function(item) {
                                var value;
                                switch (item.authorities) {
                                    case 'all':
                                        value = '全部';
                                        break;
                                    default:
                                        value = '无';
                                }
                                return value;
                            }
                        },
                        {field:'accessTokenValidity', width:120, title: '访问令牌时效', align:'center',},
                        {field:'refreshTokenValidity', width:120, title: '刷新令牌时效', align:'center',},
                        {field:'autoapprove', width:100, title: '自动授权', align:'center',
                            templet: function(item) {
                                var value;
                                switch (item.autoapprove) {
                                    case 'true':
                                        value = '启用';
                                        break;
                                    case 'false':
                                        value = '关闭';
                                        break;
                                    default:
                                        value = '无';
                                }
                                return value;
                            }
                        },
                        {field:'menuName', width:200, title: '菜单名称', align:'center',
                            templet: function(item) {
                                if(item.menuName == null || item.menuName == '') {
                                    return '未绑定';
                                }
                                return item.menuName;
                            }
                        },
                        {field:'bindMenu', width:120, title: '绑定菜单', align:'center', fixed: 'right', templet: '#bindMenu'}
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path('api/oauth2client/listpage', []),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val()
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/oauth2client/remove/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000}, function () {
                            reloadTable();
                        });
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        // 绑定菜单
        function bindMenu(clientId, menuId) {
            var message = null;
            var successMessage = null;
            if(menuId) {
                message = '确定关联？';
                successMessage = '关联成功';
            } else {
                message = top.dataMessage.bind + '绑定后，根节点菜单将自动生成';
                successMessage = top.dataMessage.bindSuccess;
            }

            top.dialog.msg(message, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.put(top.restAjax.path('api/oauth2client/update-menu-init/{clientId}?menuId={menuId}', [clientId, menuId ? menuId : '']), {}, null, function (code, data) {
                        top.dialog.msg(successMessage, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.binding, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        // 关联菜单
        function contactMenu(clientId, menuId) {
            top.dialog.open({
                title: '选择菜单',
                width: '300px',
                height: '400px',
                url: top.restAjax.path('route/menu/list-tree-root?menuId={menuId}', [menuId]),
                onClose: function() {
                    var menuId = top.dialog.dialogData.menuId;
                    if(!menuId) {
                        return;
                    }
                    bindMenu(clientId, menuId);
                }
            })
        }
        // 解绑菜单
        function unBindMenu(clientId) {
            top.dialog.msg('确定解绑吗？', {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.put(top.restAjax.path('api/oauth2client/update-menu-empty/{clientId}', [clientId]), {}, null, function (code, data) {
                        top.dialog.msg('解绑成功', {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.binding, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        initDate();

        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'save') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/oauth2client/save', []),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'update') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/oauth2client/update?clientId={clientId}', [checkDatas[0].clientId]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'remove') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item.clientId;
                    }
                    removeData(ids);
                }
            }
        });
        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var layEvent = obj.event;
            var tr = obj.tr;
            if(layEvent === 'bindMenu') {
                bindMenu(data.clientId);
            } else if(layEvent === 'contactMenu') {
                contactMenu(data.clientId, data.menuId);
            } else if(layEvent === 'unBindMenu') {
                unBindMenu(data.clientId);
            }
        })
    });
</script>
</body>
</html>